#ifndef C_BUFF_H
#define C_BUFF_H

#include "STC\STC8H.h"
#include "C_Comment.h"

//buff_size 必须是2的倍数-1
#define BUFF_SIZE 0x3f 
struct BUFF_DATA
{
    uchar rptr;
    uchar wptr;
    char buff[BUFF_SIZE+1];
};
#define BUFF_POP(x,d) d=x.buff[x.rptr++];x.rptr&=BUFF_SIZE
#define BUFF_PUSH(x,d) x.buff[x.wptr++] = d;x.wptr&=BUFF_SIZE
#define BUFF_HAS_DATA(x) (x.rptr != x.wptr)
#define BUFF_RESET(x) x.rptr=0;x.wptr=0
#define BUFF_CPY(src,dest) while(BUFF_HAS_DATA(src)){dest.buff[dest.wptr++] = src.buff[src.rptr++];src.rptr&=BUFF_SIZE;dest.wptr&=BUFF_SIZE;}

#define PBUFF_POP(x,d) d=x->buff[x->rptr++];x->rptr&=BUFF_SIZE
#define PBUFF_PUSH(x,d) x->buff[x->wptr++] = d;x->wptr&=BUFF_SIZE
#define PBUFF_HAS_DATA(x) (x->rptr != x->wptr)
#define PBUFF_RESET(x) x->rptr=0;x->wptr=0
#define PBUFF_CPY(src,dest) while(PBUFF_HAS_DATA(src)){dest->buff[dest->wptr++] = src->buff[src->rptr++];src->rptr&=BUFF_SIZE;dest->wptr&=BUFF_SIZE;}


#endif //C_BUFF_H