#include "C_STC_TOOLS.h"
#include "C_UART.h"
#include "STRING.H"
#define L_BUFF_LEN 64
char xdata stc_buff[L_BUFF_LEN];

//功能1：	在数码管上显示字符串
void STC_SEG7_ShowString(const char *str)
{
    uchar len,pos;
    stc_buff[0] = 0x37;
    stc_buff[1] = 0x53;
    stc_buff[2] = 0x45;
    stc_buff[3] = 0x47;
    stc_buff[4] = 0x53;
    stc_buff[5] = 0x00;
    stc_buff[6] = 0x00;
    stc_buff[7] = 0x00;

    pos=8,len=0;
    while(*str)
    {
        if(*str == '.')
        {
            if(stc_buff[pos-1] == '.')//如果上一位是点,则跳过
            {
                str++;
                continue;
            }
            stc_buff[pos++] = *str++; //否则添加点,但是不算位数
        }
        else
        {
            stc_buff[pos++] = *str++;
            len++;
            if(len >=8)
            {
                if(*str == '.')
                    stc_buff[pos++] = *str;
                break;
            }
        }
    }
    stc_buff[pos] = 0;
    UartSendData(stc_buff,pos+1);
}


//功能：	控制DIP40的各个管脚上LED的状态
void STC_LED40_SendData(const char *dat,uchar size,uchar port)
{
    if (size > 6)
        size = 6;
    
    stc_buff[0] = 0x4c;
    stc_buff[1] = 0x45;
    stc_buff[2] = 0x44;
    stc_buff[3] = 0x28;
    stc_buff[4] = size+1;
    stc_buff[5] = port;
    memcpy(stc_buff+6,dat,size);
    UartSendData(stc_buff,size+6);
}

